InvokeDynamicEntry (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile.constantpool, interface: InvokeDynamicEntry
Keywords: java.lang.classfile.constantpool.InvokeDynamicEntry interface

# Interface InvokeDynamicEntry

All Superinterfaces:
  `DynamicConstantPoolEntry, PoolEntry`

public sealed interface InvokeDynamicEntry extends DynamicConstantPoolEntry
Models a `CONSTANT_InvokeDynamic_info` structure, or the symbolic reference to a dynamically-computed call site, in the constant pool of a `class` file.

The use of a `InvokeDynamicEntry` is modeled by a `DynamicCallSiteDesc` symbolic descriptor. It can be obtained from `InvokeDynamicEntry::asSymbol` and converted back to a constant pool entry through `ConstantPoolBuilder::invokeDynamicEntry`.

An invoke dynamic entry is composite:

    InvokeDynamicEntry(
        BootstrapMethodEntry bootstrap,
        NameAndTypeEntry nameAndType
    )

where the `type` in the `nameAndType` is a method descriptor string.

API Note:
  A dynamically-computed call site is frequently called a dynamic call site, or an indy, from the abbreviation of "invoke dynamic".
See Java Virtual Machine Specification:
  4.4.10 The `CONSTANT_Dynamic_info` and `CONSTANT_InvokeDynamic_info` Structures
Since:
  24
See Also:
  - `ConstantPoolBuilder::invokeDynamicEntry`
  - `DynamicCallSiteDesc`
  - Dynamically-computed call sites

- ## Field Summary

  ### Fields declared in interface PoolEntry

  `TAG_CLASS, TAG_DOUBLE, TAG_DYNAMIC, TAG_FIELDREF, TAG_FLOAT, TAG_INTEGER, TAG_INTERFACE_METHODREF, TAG_INVOKE_DYNAMIC, TAG_LONG, TAG_METHOD_HANDLE, TAG_METHOD_TYPE, TAG_METHODREF, TAG_MODULE, TAG_NAME_AND_TYPE, TAG_PACKAGE, TAG_STRING, TAG_UTF8`
  Modifier and Type
  Field
  Description
  `static final int`
  `TAG_CLASS`
  The tag for `CONSTANT_Class` constant kind.
  `static final int`
  `TAG_DOUBLE`
  The tag for `CONSTANT_Double` constant kind.
  `static final int`
  `TAG_DYNAMIC`
  The tag for `CONSTANT_Dynamic` constant kind.
  `static final int`
  `TAG_FIELDREF`
  The tag for `CONSTANT_Fieldref` constant kind.
  `static final int`
  `TAG_FLOAT`
  The tag for `CONSTANT_Float` constant kind.
  `static final int`
  `TAG_INTEGER`
  The tag for `CONSTANT_Integer` constant kind.
  `static final int`
  `TAG_INTERFACE_METHODREF`
  The tag for `CONSTANT_InterfaceMethodref` constant kind.
  `static final int`
  `TAG_INVOKE_DYNAMIC`
  The tag for `CONSTANT_InvokeDynamic` constant kind.
  `static final int`
  `TAG_LONG`
  The tag for `CONSTANT_Long` constant kind.
  `static final int`
  `TAG_METHOD_HANDLE`
  The tag for `CONSTANT_MethodHandle` constant kind.
  `static final int`
  `TAG_METHOD_TYPE`
  The tag for `CONSTANT_MethodType` constant kind.
  `static final int`
  `TAG_METHODREF`
  The tag for `CONSTANT_Methodref` constant kind.
  `static final int`
  `TAG_MODULE`
  The tag for `CONSTANT_Module` constant kind.
  `static final int`
  `TAG_NAME_AND_TYPE`
  The tag for `CONSTANT_NameAndType` constant kind.
  `static final int`
  `TAG_PACKAGE`
  The tag for `CONSTANT_Package` constant kind.
  `static final int`
  `TAG_STRING`
  The tag for `CONSTANT_String` constant kind.
  `static final int`
  `TAG_UTF8`
  The tag for `CONSTANT_Utf8` constant kind.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default DynamicCallSiteDesc`
  `asSymbol()`
  Returns a symbolic descriptor for this dynamic call site.
  `default MethodTypeDesc`
  `typeSymbol()`
  Returns a symbolic descriptor for the invocation type of this dynamic call site.

  ### Methods declared in interface DynamicConstantPoolEntry

  `bootstrap, bootstrapMethodIndex, name, nameAndType, type`
  Modifier and Type
  Method
  Description
  `BootstrapMethodEntry`
  `bootstrap()`
  Returns the entry in the bootstrap method table for this constant.
  `int`
  `bootstrapMethodIndex()`
  Returns index of the entry in the bootstrap method table for this constant.
  `default Utf8Entry`
  `name()`
  Returns the name indicated by this symbolic reference.
  `NameAndTypeEntry`
  `nameAndType()`
  Returns the name and the descriptor string indicated by this symbolic reference.
  `default Utf8Entry`
  `type()`
  Returns the descriptor string indicated by this symbolic reference.

  ### Methods declared in interface PoolEntry

  `constantPool, index, tag, width`
  Modifier and Type
  Method
  Description
  `ConstantPool`
  `constantPool()`
  Returns the constant pool this entry is from.
  `int`
  `index()`
  Returns the index within the constant pool corresponding to this entry.
  `int`
  `tag()`
  Returns the constant pool tag that describes the type of this entry.
  `int`
  `width()`
  Returns the number of constant pool slots this entry consumes.

- ## Method Details

  - ### typeSymbol

    default MethodTypeDesc typeSymbol()
    Returns a symbolic descriptor for the invocation type of this dynamic call site.
    Returns:
      a symbolic descriptor for the invocation type of this dynamic call site

  - ### asSymbol

    default DynamicCallSiteDesc asSymbol()
    Returns a symbolic descriptor for this dynamic call site.
    Returns:
      a symbolic descriptor for this dynamic call site
    See Also:
      - `ConstantPoolBuilder::invokeDynamicEntry(DynamicCallSiteDesc)`